<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>AVM2: </title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.7.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul class="tablist">
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<p><a name="hasnext2"></a></p>
<h2><a class="anchor" id="hasnext2"></a>
hasnext2</h2>
<h3><a class="anchor" id="operation"></a>
Operation</h3>
<p>Determine if the given object has any more properties.</p>
<h3><a class="anchor" id="format"></a>
Format</h3>
<div class="fragment"><pre class="fragment">hasnext2
object_reg 
index_reg
</pre></div><h3><a class="anchor" id="forms"></a>
Forms</h3>
<div class="fragment"><pre class="fragment">hasnext2 = 50 (0x32)
</pre></div> <h3><a class="anchor" id="stack"></a>
Stack</h3>
<div class="fragment"><pre class="fragment">..., =&gt; ..., value
</pre></div><h3><a class="anchor" id="description"></a>
Description</h3>
<p>object_reg and index_reg are uints that must be indexes to a local register. The value of the register at position object_reg is the object that is being enumerated and is assigned to obj. The value of the register at position index_reg must be of type int, and that value is assigned to cur_index.</p>
<p>Get the index of the next property after the property located at index cur_index on object obj. If there are no more properties on obj, then obj is set to the next object on the prototype chain of obj, and cur_index is set to the first index of that object. If there are no more objects on the prototype chain and there are no more properties on obj, then obj is set to null, and cur_index is set to 0.</p>
<p>The register at position object_reg is set to the value of obj, and the register at position index_reg is set to the value of cur_index.</p>
<p>If index is not 0, then push true. Otherwise push false.</p>
<h3><a class="anchor" id="rt_execeptions"></a>
Runtime exceptions</h3>
<p>None.</p>
<h3><a class="anchor" id="notes"></a>
Notes</h3>
<p>hasnext2 works by reference. Each time it is executed it changes the values of local registers rather than simply returning a new value. This is because the object being enumerated can change when it is necessary to walk up the prototype chain to find more properties. This is different from how hasnext works, though the two may seem similar due to the similar names. </p>
</div>
<hr class="footer"/><address class="footer"><small>Generated on Thu Jan 6 2011 10:19:15 for AVM2 by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.7.1 </small></address>
</body>
</html>
